/*
 * CTU Open 2013
 * HES
 */
package template;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

/**
 *
 * @author cteam007
 */
public class Fm {

    StringTokenizer st = new StringTokenizer("");
    BufferedReader input = new BufferedReader(new InputStreamReader(System.in));

    void useLine(String s) {
        st = new StringTokenizer(s);
    }

    String nextToken() throws Exception {
        while (!st.hasMoreTokens()) {
            st = new StringTokenizer(input.readLine());
        }
        return st.nextToken();
    }

    int nextInt() throws Exception {
        return Integer.parseInt(nextToken());
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws Exception {
        Fm instance = new Fm();
        while (instance.run()) {
        }
    }

    boolean run() throws Exception {
        String in = input.readLine();
        if (in == null) {
            return false;
        }

        useLine(in);

        int rows = nextInt();
        int cols = nextInt();

        int tileRows = nextInt();
        int tileCols = nextInt();

        /*
        int colsapper = Math.max(cols, tileCols);
        int rowsapper = Math.max(rows, tileRows);
         */

        String[] map = new String[rows]; //+ rowsapper + rowsapper + tileRows];

        /*
        String rowAddon = "";
        String colAddon = "";
        String rowAddon2 = "";
        for (int ra = 0; ra < colsapper; ra++) {
        rowAddon += ".";
        }
        for (int ra = 0; ra < tileRows; ra++) {
        rowAddon2 += ".";
        }
        for (int ra = 0; ra < colsapper + colsapper + cols + tileCols; ra++) {
        colAddon += ".";
        }
        for (int i = 0; i < rowsapper; i++) {
        map[i] = colAddon;
        }
        for (int i = rowsapper; i < rowsapper + rows; i++) {
        map[i] = rowAddon + nextToken() + rowAddon;
        }
        for (int i = rowsapper + rows; i < rows + rowsapper + rowsapper; i++) {
        map[i] = colAddon;
        }*/

        boolean xFound = false;
        for (int i = 0; i < rows; i++) {
            map[i] = nextToken();
            
            if(!xFound){
                xFound = map[i].indexOf("X") != -1;
            }
        }
         
        if(!xFound){
            System.out.println("0");
            return true;
        }
        
        if(tileRows >= rows && tileCols >= cols){
            System.out.println("1");
            return true;
        }

        /*
        System.out.println("");
        for(int i = 0; i < rows*3 ; i++){
        System.out.println(map[i]);
        }   
        System.out.println("");
         * */

        TileStructure ts = new TileStructure(rows, cols, tileRows, tileCols, map);

        int min = Integer.MAX_VALUE;

        for (int i = 0; i < ((tileRows >= rows)?(1):(tileRows)); i++) {
            for (int j = 0; j < ((tileCols >= cols)?(1):(tileCols)); j++) {
                //System.out.println("Iteration[" + (-i) + "," + (-j) + "]");
                min = Math.min(min, ts.getNumber(-i, -j));
            }
        }

        System.out.println(min);

        return true;
    }
}

class TileStructure {

    int tilesH;
    int tilesW;
    int tileRows;
    int tileCols;
    String[] map;

    public TileStructure(int rows, int cols, int tileRows, int tileCols, String[] map) {
        tilesH = rows / tileRows + ((rows % tileRows == 0) ? (0) : (1)) + 1;
        tilesW = cols / tileCols + ((cols % tileCols == 0) ? (0) : (1)) + 1;

        this.tileCols = tileCols;
        this.tileRows = tileRows;
        this.map = map;
    }

    public int getNumber(int xOffset, int yOffset) {
        int count = 0;

        for (int h = 0; h < tilesH; h++) {
            for (int w = 0; w < tilesW; w++) {
                boolean hasX = false;
                for (int ht = h * tileRows; ht < h * tileRows + tileRows && !hasX; ht++) {
                    for (int wt = w * tileCols; wt < w * tileCols + tileCols && !hasX; wt++) {
                        //System.out.print("T[" + h + "," + w + "]-[" + (ht+rows) + "," + (wt+cols) + "] = ");
                        if((ht + xOffset >= 0) && (ht + xOffset < map.length) && (wt + yOffset >= 0) && (wt + yOffset < map[0].length())){
                            if (map[ht + xOffset].charAt(wt + yOffset) == 'X') {
                                hasX = true;
                            }
                        }
                    //System.out.println("X");
                    //}else{
                    //System.out.println(".");
                    //}
                    }
                }
                if (hasX) {
                    count++;
                }
            }
        }

        return count;
    }
}
